#!/usr/bin/env bash

function miner_ver() {
  local MINER_VER=$ONEZEROMINER_VER
  [[ -z $MINER_VER ]] && MINER_VER=$MINER_LATEST_VER
  echo $MINER_VER
}

function miner_config_echo() {
  local MINER_VER=$(miner_ver)
  miner_echo_config_file "/hive/miners/$MINER_NAME/$MINER_VER/miner.conf"
}

function miner_config_gen() {
  local MINER_CONFIG="$MINER_DIR/$MINER_VER/miner.conf"
  mkfile_from_symlink $MINER_CONFIG

  local conf=

  [[ -z $ONEZEROMINER_TEMPLATE ]] && echo -e "${YELLOW}TEMPLATE is empty${NOCOLOR}" && return 1
  [[ -z $ONEZEROMINER_URL ]] && echo -e "${YELLOW}URL is empty${NOCOLOR}" && return 1
  [[ -z $ONEZEROMINER_ALGO ]] && echo -e "${YELLOW}ALGO is empty${NOCOLOR}" && return 1

  algo=$ONEZEROMINER_ALGO

  local pool=
  while read -r line; do
    [[ ! -z $pool ]] && pool+=','
    pool+=$line
  done <<< "$ONEZEROMINER_URL"
  conf+=" -o $pool"

  conf+=" -w $ONEZEROMINER_TEMPLATE"
  [[ -n $ONEZEROMINER_PASS ]] && conf+=" -p $ONEZEROMINER_PASS"

  [[ -n $ONEZEROMINER_USER_CONFIG ]] && conf+=" $ONEZEROMINER_USER_CONFIG"
  
  [[ ! $ONEZEROMINER_USER_CONFIG =~ "-a " ]] && conf="-a ${algo}${conf}"

  echo "$conf" > "$MINER_CONFIG"
}
